      SUBROUTINE aa_tf_eulerxyz2rotmat(e1, e2, e3, R) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION R(3,3)
      R(1,1) = cos(e2)*cos(e3)
      R(1,2) = -cos(e2)*sin(e3)
      R(1,3) = sin(e2)
      R(2,1) = cos(e1)*sin(e3)+sin(e1)*sin(e2)*cos(e3)
      R(2,2) = cos(e1)*cos(e3)-sin(e1)*sin(e2)*sin(e3)
      R(2,3) = -sin(e1)*cos(e2)
      R(3,1) = sin(e1)*sin(e3)-cos(e1)*sin(e2)*cos(e3)
      R(3,2) = cos(e1)*sin(e2)*sin(e3)+sin(e1)*cos(e3)
      R(3,3) = cos(e1)*cos(e2)
      RETURN
      END
      SUBROUTINE aa_tf_eulerxyz2quat(e1, e2, e3, q) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION q(4)
      DOUBLE PRECISION s1,c1,s2,c2,s3,c3
      s1 = sin(e1/2.0)
      c1 = cos(e1/2.0)
      s2 = sin(e2/2.0)
      c2 = cos(e2/2.0)
      s3 = sin(e3/2.0)
      c3 = cos(e3/2.0)
      q(1) = c1*s2*s3+c2*c3*s1
      q(2) = c1*c3*s2-c2*s1*s3
      q(3) = c1*c2*s3+c3*s1*s2
      q(4) = c1*c2*c3-s1*s2*s3
      call aa_tf_qnormalize(q)
      RETURN
      END
      SUBROUTINE aa_tf_eulerxzy2rotmat(e1, e2, e3, R) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION R(3,3)
      R(1,1) = cos(e2)*cos(e3)
      R(1,2) = -sin(e2)
      R(1,3) = cos(e2)*sin(e3)
      R(2,1) = sin(e1)*sin(e3)+cos(e1)*sin(e2)*cos(e3)
      R(2,2) = cos(e1)*cos(e2)
      R(2,3) = cos(e1)*sin(e2)*sin(e3)-sin(e1)*cos(e3)
      R(3,1) = sin(e1)*sin(e2)*cos(e3)-cos(e1)*sin(e3)
      R(3,2) = sin(e1)*cos(e2)
      R(3,3) = sin(e1)*sin(e2)*sin(e3)+cos(e1)*cos(e3)
      RETURN
      END
      SUBROUTINE aa_tf_eulerxzy2quat(e1, e2, e3, q) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION q(4)
      DOUBLE PRECISION s1,c1,s2,c2,s3,c3
      s1 = sin(e1/2.0)
      c1 = cos(e1/2.0)
      s2 = sin(e2/2.0)
      c2 = cos(e2/2.0)
      s3 = sin(e3/2.0)
      c3 = cos(e3/2.0)
      q(1) = c2*c3*s1-c1*s2*s3
      q(2) = c1*c2*s3-c3*s1*s2
      q(3) = c2*s1*s3+c1*c3*s2
      q(4) = s1*s2*s3+c1*c2*c3
      call aa_tf_qnormalize(q)
      RETURN
      END
      SUBROUTINE aa_tf_euleryxz2rotmat(e1, e2, e3, R) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION R(3,3)
      R(1,1) = sin(e1)*sin(e2)*sin(e3)+cos(e1)*cos(e3)
      R(1,2) = sin(e1)*sin(e2)*cos(e3)-cos(e1)*sin(e3)
      R(1,3) = sin(e1)*cos(e2)
      R(2,1) = cos(e2)*sin(e3)
      R(2,2) = cos(e2)*cos(e3)
      R(2,3) = -sin(e2)
      R(3,1) = cos(e1)*sin(e2)*sin(e3)-sin(e1)*cos(e3)
      R(3,2) = sin(e1)*sin(e3)+cos(e1)*sin(e2)*cos(e3)
      R(3,3) = cos(e1)*cos(e2)
      RETURN
      END
      SUBROUTINE aa_tf_euleryxz2quat(e1, e2, e3, q) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION q(4)
      DOUBLE PRECISION s1,c1,s2,c2,s3,c3
      s1 = sin(e1/2.0)
      c1 = cos(e1/2.0)
      s2 = sin(e2/2.0)
      c2 = cos(e2/2.0)
      s3 = sin(e3/2.0)
      c3 = cos(e3/2.0)
      q(1) = c2*s1*s3+c1*c3*s2
      q(2) = c2*c3*s1-c1*s2*s3
      q(3) = c1*c2*s3-c3*s1*s2
      q(4) = s1*s2*s3+c1*c2*c3
      call aa_tf_qnormalize(q)
      RETURN
      END
      SUBROUTINE aa_tf_euleryzx2rotmat(e1, e2, e3, R) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION R(3,3)
      R(1,1) = cos(e1)*cos(e2)
      R(1,2) = sin(e1)*sin(e3)-cos(e1)*sin(e2)*cos(e3)
      R(1,3) = cos(e1)*sin(e2)*sin(e3)+sin(e1)*cos(e3)
      R(2,1) = sin(e2)
      R(2,2) = cos(e2)*cos(e3)
      R(2,3) = -cos(e2)*sin(e3)
      R(3,1) = -sin(e1)*cos(e2)
      R(3,2) = cos(e1)*sin(e3)+sin(e1)*sin(e2)*cos(e3)
      R(3,3) = cos(e1)*cos(e3)-sin(e1)*sin(e2)*sin(e3)
      RETURN
      END
      SUBROUTINE aa_tf_euleryzx2quat(e1, e2, e3, q) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION q(4)
      DOUBLE PRECISION s1,c1,s2,c2,s3,c3
      s1 = sin(e1/2.0)
      c1 = cos(e1/2.0)
      s2 = sin(e2/2.0)
      c2 = cos(e2/2.0)
      s3 = sin(e3/2.0)
      c3 = cos(e3/2.0)
      q(1) = c1*c2*s3+c3*s1*s2
      q(2) = c1*s2*s3+c2*c3*s1
      q(3) = c1*c3*s2-c2*s1*s3
      q(4) = c1*c2*c3-s1*s2*s3
      call aa_tf_qnormalize(q)
      RETURN
      END
      SUBROUTINE aa_tf_eulerzxy2rotmat(e1, e2, e3, R) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION R(3,3)
      R(1,1) = cos(e1)*cos(e3)-sin(e1)*sin(e2)*sin(e3)
      R(1,2) = -sin(e1)*cos(e2)
      R(1,3) = cos(e1)*sin(e3)+sin(e1)*sin(e2)*cos(e3)
      R(2,1) = cos(e1)*sin(e2)*sin(e3)+sin(e1)*cos(e3)
      R(2,2) = cos(e1)*cos(e2)
      R(2,3) = sin(e1)*sin(e3)-cos(e1)*sin(e2)*cos(e3)
      R(3,1) = -cos(e2)*sin(e3)
      R(3,2) = sin(e2)
      R(3,3) = cos(e2)*cos(e3)
      RETURN
      END
      SUBROUTINE aa_tf_eulerzxy2quat(e1, e2, e3, q) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION q(4)
      DOUBLE PRECISION s1,c1,s2,c2,s3,c3
      s1 = sin(e1/2.0)
      c1 = cos(e1/2.0)
      s2 = sin(e2/2.0)
      c2 = cos(e2/2.0)
      s3 = sin(e3/2.0)
      c3 = cos(e3/2.0)
      q(1) = c1*c3*s2-c2*s1*s3
      q(2) = c1*c2*s3+c3*s1*s2
      q(3) = c1*s2*s3+c2*c3*s1
      q(4) = c1*c2*c3-s1*s2*s3
      call aa_tf_qnormalize(q)
      RETURN
      END
      SUBROUTINE aa_tf_eulerzyx2rotmat(e1, e2, e3, R) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION R(3,3)
      R(1,1) = cos(e1)*cos(e2)
      R(1,2) = cos(e1)*sin(e2)*sin(e3)-sin(e1)*cos(e3)
      R(1,3) = sin(e1)*sin(e3)+cos(e1)*sin(e2)*cos(e3)
      R(2,1) = sin(e1)*cos(e2)
      R(2,2) = sin(e1)*sin(e2)*sin(e3)+cos(e1)*cos(e3)
      R(2,3) = sin(e1)*sin(e2)*cos(e3)-cos(e1)*sin(e3)
      R(3,1) = -sin(e2)
      R(3,2) = cos(e2)*sin(e3)
      R(3,3) = cos(e2)*cos(e3)
      RETURN
      END
      SUBROUTINE aa_tf_eulerzyx2quat(e1, e2, e3, q) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION q(4)
      DOUBLE PRECISION s1,c1,s2,c2,s3,c3
      s1 = sin(e1/2.0)
      c1 = cos(e1/2.0)
      s2 = sin(e2/2.0)
      c2 = cos(e2/2.0)
      s3 = sin(e3/2.0)
      c3 = cos(e3/2.0)
      q(1) = c1*c2*s3-c3*s1*s2
      q(2) = c2*s1*s3+c1*c3*s2
      q(3) = c2*c3*s1-c1*s2*s3
      q(4) = s1*s2*s3+c1*c2*c3
      call aa_tf_qnormalize(q)
      RETURN
      END
      SUBROUTINE aa_tf_eulerxyx2rotmat(e1, e2, e3, R) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION R(3,3)
      R(1,1) = cos(e2)
      R(1,2) = sin(e2)*sin(e3)
      R(1,3) = sin(e2)*cos(e3)
      R(2,1) = sin(e1)*sin(e2)
      R(2,2) = cos(e1)*cos(e3)-sin(e1)*cos(e2)*sin(e3)
      R(2,3) = -cos(e1)*sin(e3)-sin(e1)*cos(e2)*cos(e3)
      R(3,1) = -cos(e1)*sin(e2)
      R(3,2) = cos(e1)*cos(e2)*sin(e3)+sin(e1)*cos(e3)
      R(3,3) = cos(e1)*cos(e2)*cos(e3)-sin(e1)*sin(e3)
      RETURN
      END
      SUBROUTINE aa_tf_eulerxyx2quat(e1, e2, e3, q) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION q(4)
      DOUBLE PRECISION s1,c1,s2,c2,s3,c3
      s1 = sin(e1/2.0)
      c1 = cos(e1/2.0)
      s2 = sin(e2/2.0)
      c2 = cos(e2/2.0)
      s3 = sin(e3/2.0)
      c3 = cos(e3/2.0)
      q(1) = c1*c2*s3+c2*c3*s1
      q(2) = s1*s2*s3+c1*c3*s2
      q(3) = c3*s1*s2-c1*s2*s3
      q(4) = c1*c2*c3-c2*s1*s3
      call aa_tf_qnormalize(q)
      RETURN
      END
      SUBROUTINE aa_tf_eulerxzx2rotmat(e1, e2, e3, R) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION R(3,3)
      R(1,1) = cos(e2)
      R(1,2) = -sin(e2)*cos(e3)
      R(1,3) = sin(e2)*sin(e3)
      R(2,1) = cos(e1)*sin(e2)
      R(2,2) = cos(e1)*cos(e2)*cos(e3)-sin(e1)*sin(e3)
      R(2,3) = -cos(e1)*cos(e2)*sin(e3)-sin(e1)*cos(e3)
      R(3,1) = sin(e1)*sin(e2)
      R(3,2) = cos(e1)*sin(e3)+sin(e1)*cos(e2)*cos(e3)
      R(3,3) = cos(e1)*cos(e3)-sin(e1)*cos(e2)*sin(e3)
      RETURN
      END
      SUBROUTINE aa_tf_eulerxzx2quat(e1, e2, e3, q) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION q(4)
      DOUBLE PRECISION s1,c1,s2,c2,s3,c3
      s1 = sin(e1/2.0)
      c1 = cos(e1/2.0)
      s2 = sin(e2/2.0)
      c2 = cos(e2/2.0)
      s3 = sin(e3/2.0)
      c3 = cos(e3/2.0)
      q(1) = c1*c2*s3+c2*c3*s1
      q(2) = c1*s2*s3-c3*s1*s2
      q(3) = s1*s2*s3+c1*c3*s2
      q(4) = c1*c2*c3-c2*s1*s3
      call aa_tf_qnormalize(q)
      RETURN
      END
      SUBROUTINE aa_tf_euleryxy2rotmat(e1, e2, e3, R) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION R(3,3)
      R(1,1) = cos(e1)*cos(e3)-sin(e1)*cos(e2)*sin(e3)
      R(1,2) = sin(e1)*sin(e2)
      R(1,3) = cos(e1)*sin(e3)+sin(e1)*cos(e2)*cos(e3)
      R(2,1) = sin(e2)*sin(e3)
      R(2,2) = cos(e2)
      R(2,3) = -sin(e2)*cos(e3)
      R(3,1) = -cos(e1)*cos(e2)*sin(e3)-sin(e1)*cos(e3)
      R(3,2) = cos(e1)*sin(e2)
      R(3,3) = cos(e1)*cos(e2)*cos(e3)-sin(e1)*sin(e3)
      RETURN
      END
      SUBROUTINE aa_tf_euleryxy2quat(e1, e2, e3, q) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION q(4)
      DOUBLE PRECISION s1,c1,s2,c2,s3,c3
      s1 = sin(e1/2.0)
      c1 = cos(e1/2.0)
      s2 = sin(e2/2.0)
      c2 = cos(e2/2.0)
      s3 = sin(e3/2.0)
      c3 = cos(e3/2.0)
      q(1) = s1*s2*s3+c1*c3*s2
      q(2) = c1*c2*s3+c2*c3*s1
      q(3) = c1*s2*s3-c3*s1*s2
      q(4) = c1*c2*c3-c2*s1*s3
      call aa_tf_qnormalize(q)
      RETURN
      END
      SUBROUTINE aa_tf_euleryzy2rotmat(e1, e2, e3, R) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION R(3,3)
      R(1,1) = cos(e1)*cos(e2)*cos(e3)-sin(e1)*sin(e3)
      R(1,2) = -cos(e1)*sin(e2)
      R(1,3) = cos(e1)*cos(e2)*sin(e3)+sin(e1)*cos(e3)
      R(2,1) = sin(e2)*cos(e3)
      R(2,2) = cos(e2)
      R(2,3) = sin(e2)*sin(e3)
      R(3,1) = -cos(e1)*sin(e3)-sin(e1)*cos(e2)*cos(e3)
      R(3,2) = sin(e1)*sin(e2)
      R(3,3) = cos(e1)*cos(e3)-sin(e1)*cos(e2)*sin(e3)
      RETURN
      END
      SUBROUTINE aa_tf_euleryzy2quat(e1, e2, e3, q) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION q(4)
      DOUBLE PRECISION s1,c1,s2,c2,s3,c3
      s1 = sin(e1/2.0)
      c1 = cos(e1/2.0)
      s2 = sin(e2/2.0)
      c2 = cos(e2/2.0)
      s3 = sin(e3/2.0)
      c3 = cos(e3/2.0)
      q(1) = c3*s1*s2-c1*s2*s3
      q(2) = c1*c2*s3+c2*c3*s1
      q(3) = s1*s2*s3+c1*c3*s2
      q(4) = c1*c2*c3-c2*s1*s3
      call aa_tf_qnormalize(q)
      RETURN
      END
      SUBROUTINE aa_tf_eulerzxz2rotmat(e1, e2, e3, R) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION R(3,3)
      R(1,1) = cos(e1)*cos(e3)-sin(e1)*cos(e2)*sin(e3)
      R(1,2) = -cos(e1)*sin(e3)-sin(e1)*cos(e2)*cos(e3)
      R(1,3) = sin(e1)*sin(e2)
      R(2,1) = cos(e1)*cos(e2)*sin(e3)+sin(e1)*cos(e3)
      R(2,2) = cos(e1)*cos(e2)*cos(e3)-sin(e1)*sin(e3)
      R(2,3) = -cos(e1)*sin(e2)
      R(3,1) = sin(e2)*sin(e3)
      R(3,2) = sin(e2)*cos(e3)
      R(3,3) = cos(e2)
      RETURN
      END
      SUBROUTINE aa_tf_eulerzxz2quat(e1, e2, e3, q) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION q(4)
      DOUBLE PRECISION s1,c1,s2,c2,s3,c3
      s1 = sin(e1/2.0)
      c1 = cos(e1/2.0)
      s2 = sin(e2/2.0)
      c2 = cos(e2/2.0)
      s3 = sin(e3/2.0)
      c3 = cos(e3/2.0)
      q(1) = s1*s2*s3+c1*c3*s2
      q(2) = c3*s1*s2-c1*s2*s3
      q(3) = c1*c2*s3+c2*c3*s1
      q(4) = c1*c2*c3-c2*s1*s3
      call aa_tf_qnormalize(q)
      RETURN
      END
      SUBROUTINE aa_tf_eulerzyz2rotmat(e1, e2, e3, R) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION R(3,3)
      R(1,1) = cos(e1)*cos(e2)*cos(e3)-sin(e1)*sin(e3)
      R(1,2) = -cos(e1)*cos(e2)*sin(e3)-sin(e1)*cos(e3)
      R(1,3) = cos(e1)*sin(e2)
      R(2,1) = cos(e1)*sin(e3)+sin(e1)*cos(e2)*cos(e3)
      R(2,2) = cos(e1)*cos(e3)-sin(e1)*cos(e2)*sin(e3)
      R(2,3) = sin(e1)*sin(e2)
      R(3,1) = -sin(e2)*cos(e3)
      R(3,2) = sin(e2)*sin(e3)
      R(3,3) = cos(e2)
      RETURN
      END
      SUBROUTINE aa_tf_eulerzyz2quat(e1, e2, e3, q) 
      DOUBLE PRECISION e1,e2,e3
      DOUBLE PRECISION q(4)
      DOUBLE PRECISION s1,c1,s2,c2,s3,c3
      s1 = sin(e1/2.0)
      c1 = cos(e1/2.0)
      s2 = sin(e2/2.0)
      c2 = cos(e2/2.0)
      s3 = sin(e3/2.0)
      c3 = cos(e3/2.0)
      q(1) = c1*s2*s3-c3*s1*s2
      q(2) = s1*s2*s3+c1*c3*s2
      q(3) = c1*c2*s3+c2*c3*s1
      q(4) = c1*c2*c3-c2*s1*s3
      call aa_tf_qnormalize(q)
      RETURN
      END
